#define MYVERSION "1.2.1"

/*
	change log

2023-04-20 15:00 GMT - Mark P v1.2.1
 - Upload to latest SDK (2023-04-18)

2022-12-11 14:00 GMT - Mark P v1.2
- The 'Codec' field is now correctly populated with the internal type of AdPlug file in the Details tab of the File Info.
  You may need to Reload Tag Info to see it.
- The player status bar codec is set to only report the file extension, to mirror the observed behaviour of similar plugins 
  (foo_openmpt54).
- The component is now correctly packaged for simple installation.
- The plugin's Preferences panel is now accessible from the Decoding panel.
- Handling of S3M files has been re-enabled. I have set this plugin as low merit so it will not take over 
  exising handlers on first installation of foo_adplug. If you are updating and want to use your 
  existing decoders for s3m files (as most probably will), them move foo_adplug down the priority list in 
  the Decoding prefs.
- Added a new sample rate of 52781, to match foo_gep for VGM decoding.
- MIDI files are disabled, would recommend using foo_midi instead.

2022-12-10 23:01 GMT - Mark P
- Enabled Support for Dark Mode
- All headers now sensibly organised.
- Now builds with the Visual Studio 2022 Compiler, against the Windows 10 SDK.
- All ATLHelpers hacks removed, now using default SDK files. UI handling now much more sane.
- All Build Configurations now working (x86, and x64, in Debug and Release modes).
- Renamed Equaliser to Filter
- Adds the copyright notices for the AdPlug library.
- Made the default WoodyOPL as this has better Seek behaviour.
- Version is now 1.1

2022-12-09 4:00 GMT - Mark P

- Based on the superb original work from Kode54.
- Renamed to foo_adplug.dll

Optimisations
	- Removed the built-in tags database, this is now better handled through a plugin such as foo_external_tags.
	- Removed the built in built-in reampler, this is now much better handled through built-in Foobar2000 capabilities.
	- Removed the built-in 'Surround Sound' function, this is now much better handled through other Foobar plugins.
	- Removed the standalone DOSBox core, this is now handled by AdPlug as WoodyOPL
	- Removed the exclusion of .lds files
	- Removed all the various sample rates, just leaving the 49516 and 49716 per 
	  http://nerdlypleasures.blogspot.com/2018/01/opl23-frequency-1hz-ish-difference.html
	- Re-enabled .adl file handing. It's not right, but it will at least allow you to play your songs.
	- Tidied up the UI a little.

- Updated to the latest Foobar2000 SDK
	- Enabled 64bit builds
	- Made 'usable' in Visual Studio 2022 Professional

- Updated to the latest AdPlug from Git
	- Added all the software OPL cores from AdPlug.
	- Set the default core to Nuked OPL3 at 49716Hz

- ToDo:
	- The UI handling is a messy hack, can someone rebuild using the latest PPUI libraries and support dark mode?
	- The adplug, libbinio and the plugin itself needs to be built with the Windows XP compiler tools (v141_xp),
	  against the 7.0 SDK. This needs updating to something more modern and sustainable.
	- The includes are a mess, they need putting at the correct paths.
	- I haven't bothered getting anything other than x64 release builds working.
	- The plugin builds to a .dll only, it is not packaged.
	- The 'Jarek Burczynski' decoder only seems to render the left channel.
	- The 'configure' link is missing from the Filters view.

- Warnings
	- If you have added APE tags to your Adlib files, this may cause the length to be reported incorrectly. I would suggest
	  removing these and using an external tagger.

2014-06-13 22:15 UTC - kode54
- Replaced the ESS FM impulse with one which was hand equalized by passing_by, fitting
  since it was captured from his own ESS FM
- Version is now 1.46

2014-06-13 05:23 UTC - kode54
- Fixed a possible looping bug with IMF files

2014-06-13 04:52 UTC - kode54
- Implemented new convolver based on KISS-FFT

2014-06-12 05:50 UTC - kode54
- Enabled convolver again, now with an equalizer generated impulse, partially truncated
- Made convolver optional, enabled to use ESS FM preset by default

2014-04-14 06:25 UTC - kode54
- Updated Adplug's YMF262 emulator
- Replaced lanczos_resampler.c with resampler.c, which improves downsampling quality
- Disabled the convolver, as the impulse is wrong, and my implementation is quite slow
- Version is now 1.45

2014-01-26 08:26 UTC - kode54
- Generated a proper minimum phase impulse for the convolver

2013-11-26 00:30 UTC - kode54
- Implemented simple time domain impulse convolver based on ESS-FM chip

2013-05-05 17:56 UTC - kode54
- Changed optimization settings
- Version is now 1.44

2013-05-05 03:52 UTC - kode54
- Minor optimization and fix to the Lanczos resampler
- Version is now 1.43

2013-05-03 01:17 UTC - kode54
- Replaced blargg's Fir_Resampler with a different Lanczos sinc resampler

2013-01-08 01:45 UTC - kode54
- Changed Adlib chips to always render at their native sample rate
- Version is now 1.42

2012-09-24 11:38 UTC - kode54
- Updated AdPlug
- Version is now 1.41

2012-02-19 19:49 UTC - kode54
- Added abort check to decoder
- Version is now 1.40

2011-02-14 17:48 UTC - kode54
- Fixed string compare which caused "a" to be added to all reported file name
  extensions except for .LDS
- Version is now 1.39

2011-02-14 11:43 UTC - kode54
- Shunted out LDS extension to make way for the new support in foo_midi
- Version is now 1.38

2010-08-18 00:19 UTC - kode54
- Implemented support for the Adlib Surround virtual emulator core
- Version is now 1.37

2010-08-10 20:34 UTC - kode54
- Added pipes to path separator splitting in AdPlug, for archives
- Version is now 1.36

2010-04-22 16:41 UTC - kode54
- Updated to latest AdPlug CVS
- Fixed a crash bug in the HSC player
- Version is now 1.35

2010-04-13 14:53 UTC - kode54
- Amended preferences WM_INITDIALOG handler
- Version is now 1.34

2010-01-11 11:25 UTC - kode54
- Updated preferences page to 1.0 API
- Version is now 1.33

2009-11-08 23:08 UTC - kode54
- Added extra debug logging so I can attempt to track down stupid crashes
- Version is now 1.32

2009-09-03 06:20 UTC - kode54
- Added file not found exception catch around database loader in input class
- Version is now 1.31

2009-08-28 07:56 UTC - kode54
- Updated Harekiet's OPL emulator to latest from Dosbox
- Doubled the volume output from Harekiet's OPL emulator
- Version is now 1.3

2009-07-22 04:32 UTC - kode54
- Disabled the ADL reader until it can be fixed
- Version is now 1.21

2009-05-03 04:38 UTC - kode54
- Implemented Harekiet's OPL emulator core and configuration
- Version is now 1.2

2009-03-30 01:00 UTC - kode54
- Implemented Ken Silverman's Adlib emulator core and configuration
- Version is now 1.1

2008-10-16 02:48 UTC - kode54
- Implemented database checking for live updates.
- Added artist and comment meta fields.

2008-10-07 - kode54
- Initial release.

*/

#include "fileprovider.h"

#include "stdafx.h"
#include "resource.h"

#include <helpers/atl-misc.h>
#include <helpers/darkmode.h>
#include "helpers/dropdown_helper.h"

#include <adplug.h>
#include <emuopl.h>
#include <kemuopl.h>
#include <nemuopl.h>
#include <temuopl.h>
#include <wemuopl.h>

#include "simple_convolver.h"

// Configuration Property GUIDs
	// {0BD2647E-90FE-4d99-BE78-D3DCC5B22E87}
	static const GUID guid_cfg_samplerate = 
	{ 0xbd2647e, 0x90fe, 0x4d99, { 0xbe, 0x78, 0xd3, 0xdc, 0xc5, 0xb2, 0x2e, 0x87 } };
	// {FDA94358-952F-4133-8542-7A75E1C5EABF}
	static const GUID guid_cfg_history_rate = 
	{ 0xfda94358, 0x952f, 0x4133, { 0x85, 0x42, 0x7a, 0x75, 0xe1, 0xc5, 0xea, 0xbf } };
	// {A526C7E1-3BC6-4ddb-BD6A-C5A0F5D725FE}
	static const GUID guid_cfg_adlib_core = 
	{ 0xa526c7e1, 0x3bc6, 0x4ddb, { 0xbd, 0x6a, 0xc5, 0xa0, 0xf5, 0xd7, 0x25, 0xfe } };
	// {06219814-62E9-4B12-847F-CC4E631F2112}
	static const GUID guid_cfg_equalizer_preset = 
	{ 0x6219814, 0x62e9, 0x4b12, { 0x84, 0x7f, 0xcc, 0x4e, 0x63, 0x1f, 0x21, 0x12 } };

// Preferences GUID
	// Originally (Kode54) {61DC98D5-A3A3-42a8-B555-97C355FE21D3}
	// New (Mark P)        {775d22c5-1bbd-4842-bbf7-0fe82aa3f1a0}
	static const GUID guid_prefs_foo_adplug = { 0x775d22c5, 0x1bbd, 0x4842, { 0xbb, 0xf7, 0x0f, 0xe8, 0x2a, 0xa3, 0xf1, 0xa0 } };

	// Plugin GUID
	// Originally (Kode54) {AE29C554-EE59-4C1A-8211-320F2A1A992B}
	// New (Mark P)        {ad3f24d3-067f-4597-83c3-f7b443837bac}
	static const GUID guid_input_foo_adplug = { 0xad3f24d3, 0x067f, 0x4597, { 0x83, 0xc3, 0xf7, 0xb4, 0x43, 0x83, 0x7b, 0xac } };

enum
{
	default_cfg_samplerate = 49716,
	default_cfg_adlib_core = 3,
	default_cfg_equalizer_preset = 0,
};

static cfg_int cfg_samplerate( guid_cfg_samplerate, default_cfg_samplerate );
static cfg_int cfg_adlib_core( guid_cfg_adlib_core, default_cfg_adlib_core );
static cfg_int cfg_equalizer_preset( guid_cfg_equalizer_preset, default_cfg_equalizer_preset );


class initquit_adplug : public initquit
{
public:
	void on_init()	{	}
};

static Copl * create_adlib( unsigned core, unsigned srate, bool stereo = true )
{
	Copl * p_emu = NULL;

	//uSendMessageText(w, CB_ADDSTRING, 0, "Ken Silverman's");
	//uSendMessageText(w, CB_ADDSTRING, 0, "Jarek Burczynski's");
	//uSendMessageText(w, CB_ADDSTRING, 0, "Tatsuyuki Satoh's");
	//uSendMessageText(w, CB_ADDSTRING, 0, "WoodyOPL (DOSBox)");
	//uSendMessageText(w, CB_ADDSTRING, 0, "Nuked OPL3");

	switch ( core )
	{
		case 0:	p_emu = new CKemuopl(srate, true, stereo); break;
		case 1:	p_emu = new CEmuopl(srate, true, stereo); break;
		case 2:	p_emu = new CTemuopl(srate, true, stereo); break;
		case 3:	p_emu = new CWemuopl(srate, true, stereo); break;
		case 4:	p_emu = new CNemuopl(srate);
	}

	return p_emu;
}

class input_adplug : public input_stubs
{
	CPlayer        * m_player;
	Copl           * m_emu;
	void           * m_convolver[2];

	t_filestats m_stats;
	t_filestats2 m_stats2;

	unsigned srate;
	bool first_block, dont_loop;
	unsigned subsong, samples_todo;
	double seconds;
	bool eof;

	pfc::array_t< t_int16 > intermediate_buffer;
	pfc::array_t< t_int32 > sample_buffer;
	pfc::array_t< unsigned long > lengths;
	pfc::string8 file_type;

public:
	service_ptr_t<file> m_file;

public:
	input_adplug()
	{
		m_player = 0;
		m_emu = 0;

		m_convolver[0] = 0;
		m_convolver[1] = 0;
	}

	static const char* g_get_name()	{ return "AdPlug OPL Player"; }
	static GUID g_get_guid() { return guid_input_foo_adplug; }
	static GUID g_get_preferences_guid() { return guid_prefs_foo_adplug; }

	~input_adplug()
	{
		delete m_player;
		delete m_emu;

		convolver_delete( m_convolver[0] );
		convolver_delete( m_convolver[1] );
	}

	void open( service_ptr_t<file> p_filehint, const char * p_path, t_input_open_reason p_reason, abort_callback & p_abort )
	{
		if (p_reason == input_open_info_write) throw exception_tagging_unsupported();//our input does not support retagging.

		m_file = p_filehint;//p_filehint may be null, hence next line
		input_open_file_helper(m_file, p_path, p_reason, p_abort);//if m_file is null, opens file with appropriate privileges for our operation (read/write for writing tags, read-only otherwise).

		srate = cfg_samplerate;
		file_type = pfc::stringToUpper(pfc::string_extension(p_path));

		m_emu = create_adlib( cfg_adlib_core, srate );

		m_convolver[0] = convolver_create( cfg_equalizer_preset );
		m_convolver[1] = convolver_create( cfg_equalizer_preset );

		pfc::string8 path = p_path;

		{
			m_player = CAdPlug::factory( std::string( path ), m_emu, CAdPlug::players, CProvider_foobar2000( std::string( p_path ), m_file, p_abort ) );
			if ( ! m_player )
				throw exception_io_data();
		}

	}

	unsigned get_subsong_count() { return m_player->getsubsongs(); }
	t_uint32 get_subsong(unsigned p_index) { return p_index; }

	void get_info( t_uint32 p_subsong, file_info & p_info, abort_callback & p_abort )
	{

		p_info.info_set("encoding", "synthesized" );
		p_info.info_set_int( "channels", 2 );
		if (!m_player->gettype().empty())
			p_info.info_set("codec", file_type);
			p_info.info_set("codec_profile", pfc::stringcvt::string_utf8_from_ansi(m_player->gettype().c_str()));
		if ( !m_player->gettitle().empty() )
			p_info.meta_set( "title", pfc::stringcvt::string_utf8_from_ansi( m_player->gettitle().c_str() ) );
		if ( !m_player->getauthor().empty() )
			p_info.meta_set( "artist", pfc::stringcvt::string_utf8_from_ansi( m_player->getauthor().c_str() ) );
		if ( !m_player->getdesc().empty() )
			p_info.meta_set( "comment", pfc::stringcvt::string_utf8_from_ansi( m_player->getdesc().c_str() ) );

		p_info.set_length( m_player->songlength( p_subsong ) / 1000. );
	}

	t_filestats2 get_stats2(unsigned f, abort_callback& p_abort ) { return m_file->get_stats2_(f, p_abort); }
	t_filestats get_file_stats(abort_callback& p_abort) { return m_file->get_stats(p_abort); }

	void decode_initialize( t_uint32 p_subsong, unsigned p_flags, abort_callback & p_abort )
	{
		m_file->reopen(p_abort);//equivalent to seek to zero, except it also works on nonseekable streams
		
		first_block = true;
		samples_todo = 0;
		seconds = 0;
		eof = false;
		subsong = p_subsong;

		m_emu->init();

		convolver_clear( m_convolver[0] );
		convolver_clear( m_convolver[1] );

		m_player->rewind( subsong );

		intermediate_buffer.set_size( 2048 * 2 );
		sample_buffer.set_size( 2048 * 2 );
		dont_loop = !!(p_flags & input_flag_no_looping) || !false;
	}

	bool render(int16_t * sample_buffer, int count)
	{
		bool running = true;
		while ( count )
		{
			if ( !samples_todo )
			{
				running = m_player->update() && running;
				if ( !dont_loop || running )
				{
					samples_todo = srate / m_player->getrefresh();
					seconds += 1.0 / m_player->getrefresh();
				}
			}
			if ( !samples_todo )
				break;
			int samples_now = samples_todo;
			if ( samples_now > count )
				samples_now = count;
			m_emu->update( sample_buffer, samples_now );
			sample_buffer += samples_now * 2;
			samples_todo -= samples_now;
			count -= samples_now;
		}
		if ( count )
			memset( sample_buffer, 0, count * 4 );
		return !running;
	}

public:
	bool decode_run(audio_chunk & p_chunk,abort_callback & p_abort)
	{
		p_abort.check();

		if ( dont_loop && eof )
			return false;

			unsigned sample_count = 2048;

			int samples_done = 0;
			while ( samples_done < sample_count )
			{
				int samples_ready = convolver_ready( m_convolver[0] );
				if ( !samples_ready )
				{
					int to_fill = convolver_get_free_count( m_convolver[0] );
					intermediate_buffer.grow_size( ( samples_done + to_fill ) * 2 );
					eof = render( intermediate_buffer.get_ptr() + samples_done * 2, to_fill );
					for ( unsigned i = 0; i < to_fill; i++ )
					{
						convolver_write( m_convolver[0], intermediate_buffer[(samples_done + i) * 2 + 0] );
						convolver_write( m_convolver[1], intermediate_buffer[(samples_done + i) * 2 + 1] );
					}
					samples_ready = convolver_ready( m_convolver[0] );
				}
				int samples_todo = sample_count - samples_done;
				if ( samples_todo > samples_ready )
					samples_todo = samples_ready;
				for ( unsigned i = 0; i < samples_todo; i++ )
				{
					intermediate_buffer[(samples_done + i) * 2 + 0] = convolver_read( m_convolver[0] );
					intermediate_buffer[(samples_done + i) * 2 + 1] = convolver_read( m_convolver[1] );
				}
				samples_done += samples_todo;
			}

			p_chunk.set_data_fixedpoint( intermediate_buffer.get_ptr(), sample_count * 4, srate, 2, 16, audio_chunk::channel_config_stereo );

		return true;
	}

	void decode_seek( double p_seconds, abort_callback & p_abort )
	{
		first_block = true;
		eof = false;
		samples_todo = 0;

		convolver_clear( m_convolver[0] );
		convolver_clear( m_convolver[1] );

		if ( p_seconds < seconds )
		{
			seconds = 0;
			m_player->rewind( subsong );
		}

		while ( seconds < p_seconds )
		{
			p_abort.check();
			m_player->update();
			seconds += 1. / m_player->getrefresh();
		}

		samples_todo = ( seconds - p_seconds ) * (float)srate;
	}

	bool decode_can_seek() { return m_file->can_seek(); }

	bool decode_get_dynamic_info(file_info & p_out, double & p_timestamp_delta)
	{
		if ( first_block )
		{
			p_out.info_set_int( "samplerate", srate );
			first_block = false;
			return true;
		}
		return false;
	}

	bool decode_get_dynamic_info_track(file_info& p_out, double& p_timestamp_delta) { return false; } // deals with dynamic information such as track changes in live streams
	void decode_on_idle(abort_callback& p_abort) { m_file->on_idle(p_abort); }

	// Note that open() already rejects requests to open for tag writing, so these two should never get called.
	void retag(const file_info& p_info, abort_callback& p_abort) { throw exception_tagging_unsupported(); }
	void remove_tags(abort_callback&) { throw exception_tagging_unsupported(); }
	void retag_set_info( t_uint32 p_subsong, const file_info & p_info, abort_callback & p_abort ) { throw exception_tagging_unsupported(); }
	void retag_commit(abort_callback&) { throw exception_tagging_unsupported(); }

	static bool g_is_our_content_type(const char* p_content_type) { return false; } // match against supported mime types here
	static bool g_is_low_merit() { return true; }

	static bool g_is_our_path( const char* p_path, const char* p_extension )
	{
		if (!stricmp_utf8(p_extension, "mid")) { return false; }
		const CPlayers & pl = CAdPlug::players;

		CPlayers::const_iterator i;
		unsigned                 j;
		
		for ( i = pl.begin(); i != pl.end(); ++i )
		{
			for ( j = 0; ( *i )->get_extension( j ); ++j )
			{
				if ( !stricmp_utf8( p_extension, ( *i )->get_extension( j ) + 1 ) )
					return true;
			}
		}

		return false;
	}
};

class adplug_file_types : public input_file_type
{
	virtual unsigned get_count()
	{
		const CPlayers & pl = CAdPlug::players;
		return pl.size();
	}

	virtual bool get_name(unsigned idx, pfc::string_base & out)
	{
		const CPlayers & pl = CAdPlug::players;
		CPlayers::const_iterator i;
		unsigned                 j;
		for ( i = pl.begin(), j = 0; i != pl.end() && j != idx; ++i, ++j );
		out = ( *i )->filetype.c_str();
		return true;
	}

	virtual bool get_mask(unsigned idx, pfc::string_base & out)
	{
		const CPlayers & pl = CAdPlug::players;
		CPlayers::const_iterator i;
		unsigned                 j;
		for ( i = pl.begin(), j = 0; i != pl.end() && j != idx; ++i, ++j );
		const CPlayerDesc * p = *i;
		out.reset();
		for ( unsigned i = 0; p->get_extension( i ); ++i )
		{
			const char * ext = p->get_extension( i );
			if (!stricmp(ext + 1, "mid")) continue;
			if ( i ) out.add_byte( ';' );
			out.add_byte( '*' );
			out += ext;
		}
		return true;
	}

	virtual bool is_associatable(unsigned idx)
	{
		return true;
	}
};

static cfg_dropdown_history cfg_history_rate(guid_cfg_history_rate,16);

static const int srate_tab[]={49516,49716,52781};

class CMyPreferences : public CDialogImpl<CMyPreferences>, public preferences_page_instance {
public:
	//Constructor - invoked by preferences_page_impl helpers - don't do Create() in here, preferences_page_impl does this for us
	CMyPreferences(preferences_page_callback::ptr callback) : m_callback(callback) {}

	//Note that we don't bother doing anything regarding destruction of our class.
	//The host ensures that our dialog is destroyed first, then the last reference to our preferences_page_instance object is released, causing our object to be deleted.


	//dialog resource ID
	enum {IDD = IDD_CONFIG};
	// preferences_page_instance methods (not all of them - get_wnd() is supplied by preferences_page_impl helpers)
	t_uint32 get_state();
	void apply();
	void reset();

	//WTL message map
	BEGIN_MSG_MAP(CMyPreferences)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX(IDC_SAMPLERATE, CBN_EDITCHANGE, OnEditChange)
		COMMAND_HANDLER_EX(IDC_SAMPLERATE, CBN_SELCHANGE, OnSelectionChange)
		DROPDOWN_HISTORY_HANDLER(IDC_SAMPLERATE, cfg_history_rate)
		COMMAND_HANDLER_EX(IDC_ADLIBCORE, CBN_SELCHANGE, OnSelectionChange)
		COMMAND_HANDLER_EX(IDC_EQUALIZER, CBN_SELCHANGE, OnSelectionChange)
	END_MSG_MAP()
private:
	BOOL OnInitDialog(CWindow, LPARAM);
	void OnEditChange(UINT, int, CWindow);
	void OnSelectionChange(UINT, int, CWindow);
	void OnButtonClick(UINT, int, CWindow);
	bool HasChanged();
	void OnChanged();

	const preferences_page_callback::ptr m_callback;

	// Dark mode hooks object, must be a member of dialog class.
	fb2k::CDarkModeHooks m_dark;
};

BOOL CMyPreferences::OnInitDialog(CWindow, LPARAM) {

	// Enable dark mode
    // One call does it all, applies all relevant hacks automatically
	m_dark.AddDialogWithControls(*this);

	CWindow w;
	char temp[16];
	int n;
	for(n=tabsize(srate_tab);n--;)
	{
		if (srate_tab[n] != cfg_samplerate)
		{
			itoa(srate_tab[n], temp, 10);
			cfg_history_rate.add_item(temp);
		}
	}
	itoa(cfg_samplerate, temp, 10);
	cfg_history_rate.add_item(temp);
	w = GetDlgItem( IDC_SAMPLERATE );
	cfg_history_rate.setup_dropdown( w );
	::SendMessage( w, CB_SETCURSEL, 0, 0 );

	HFONT hFont = CreateFont(25, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, ANSI_CHARSET,
		OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_DONTCARE, TEXT("Tahoma"));

	w = GetDlgItem( IDC_HEADER );
	uSendMessage(w, WM_SETFONT, (WPARAM)hFont, true);

	w = GetDlgItem( IDC_ADLIBCORE );
	uSendMessageText( w, CB_ADDSTRING, 0, "Ken Silverman's" );
	uSendMessageText( w, CB_ADDSTRING, 0, "Jarek Burczynski's" );
	uSendMessageText( w, CB_ADDSTRING, 0, "Tatsuyuki Satoh's");
	uSendMessageText( w, CB_ADDSTRING, 0, "WoodyOPL (DOSBox)");
	uSendMessageText( w, CB_ADDSTRING, 0, "Nuked OPL3");
	::SendMessage( w, CB_SETCURSEL, cfg_adlib_core, 0 );

	w = GetDlgItem( IDC_EQUALIZER );
	uSendMessageText( w, CB_ADDSTRING, 0, "None" );
	uSendMessageText( w, CB_ADDSTRING, 0, "ESS FM" );
	::SendMessage( w, CB_SETCURSEL, cfg_equalizer_preset, 0 );

	return FALSE;
}

void CMyPreferences::OnEditChange(UINT, int, CWindow) {	OnChanged(); }
void CMyPreferences::OnSelectionChange(UINT, int, CWindow) { OnChanged(); }
void CMyPreferences::OnButtonClick(UINT, int, CWindow) { OnChanged(); }

t_uint32 CMyPreferences::get_state() {
	t_uint32 state = preferences_state::resettable | preferences_state::dark_mode_supported;
	if (HasChanged()) state |= preferences_state::changed;
	return state;
}

void CMyPreferences::reset() {
	SetDlgItemInt( IDC_SAMPLERATE, default_cfg_samplerate, FALSE );
	SendDlgItemMessage( IDC_ADLIBCORE, CB_SETCURSEL, default_cfg_adlib_core );
	SendDlgItemMessage( IDC_EQUALIZER, CB_SETCURSEL, default_cfg_equalizer_preset );
	
	OnChanged();
}

void CMyPreferences::apply() {
	char temp[16];
	int t = GetDlgItemInt( IDC_SAMPLERATE, NULL, FALSE );
	if ( t < 6000 ) t = 6000;
	else if ( t > 192000 ) t = 192000;
	SetDlgItemInt( IDC_SAMPLERATE, t, FALSE );
	itoa( t, temp, 10 );
	cfg_history_rate.add_item(temp);
	cfg_samplerate = t;
	cfg_adlib_core = SendDlgItemMessage( IDC_ADLIBCORE, CB_GETCURSEL );
	cfg_equalizer_preset = SendDlgItemMessage( IDC_EQUALIZER, CB_GETCURSEL );
	
	OnChanged(); //our dialog content has not changed but the flags have - our currently shown values now match the settings so the apply button can be disabled
}

bool CMyPreferences::HasChanged() {
	//returns whether our dialog content is different from the current configuration (whether the apply button should be enabled or not)
	return GetDlgItemInt( IDC_SAMPLERATE, NULL, FALSE ) != cfg_samplerate ||
		SendDlgItemMessage( IDC_ADLIBCORE, CB_GETCURSEL ) != cfg_adlib_core ||
		SendDlgItemMessage( IDC_EQUALIZER, CB_GETCURSEL ) != cfg_equalizer_preset;
}
void CMyPreferences::OnChanged() {
	//tell the host that our state has changed to enable/disable the apply button appropriately.
	m_callback->on_state_changed();
}

class preferences_page_myimpl : public preferences_page_impl<CMyPreferences> {
	// preferences_page_impl<> helper deals with instantiation of our dialog; inherits from preferences_page_v3.
public:
	const char * get_name() {return "AdPlug OPL Player";}
	GUID get_guid() { return guid_prefs_foo_adplug;	}
	GUID get_parent_guid() {return guid_input;}
};

static input_factory_t            <input_adplug>            g_input_adplug_factory;
static initquit_factory_t         <initquit_adplug>         g_initquit_adplug_factory;
static service_factory_single_t   <adplug_file_types>       g_input_file_type_adplug_factory;
static preferences_page_factory_t <preferences_page_myimpl> g_config_adplug_factory;

DECLARE_COMPONENT_VERSION( "AdPlug OPL Player", MYVERSION, "AdPlug OPL Player uses the AdPlug library.\nhttps://github.com/adplug/adplug\n\nAdPlug - A free AdLib sound player library\nAdPlug Copyright (C) 1999 - 2017 Simon Peter, et al.\n\nThis plugin is based on v1.46 of foo_input_adplug by Kode54,\nwith updates and enhancements by Mark P." );
VALIDATE_COMPONENT_FILENAME("foo_adplug.dll");